import $ from 'cash-dom'

// adding smooth scroll for panel achnor
import SmoothScroll from 'smooth-scroll'
import { throttle, debounce } from 'throttle-debounce'

$(function () {

    // create scroll
    const scroll = new SmoothScroll('.sozi-ui__menu-list a[href*="#"]')

    /**
     *  adding toggle for mobile navigation
     *
     */
    const button = $('#mobile-button')
    const navigationWrapper = $('.sozi-ui__menu-list-wrapper')
    const navigation = navigationWrapper.find('.sozi-ui__menu-list').first()

    const buttonClass = 'button--open'

    // open sidebar and button
    const handleOpen = function() {
        navigationWrapper.css('max-height', navigation.outerHeight() + 'px')
        button.addClass(buttonClass)
    }

    // close sidebar and button
    const handleClose = function() {
        navigationWrapper.css('max-height', '0px')
        button.removeClass(buttonClass)
    }

    button.on('click', (event) => {
        event.preventDefault()

        if (navigationWrapper.css('max-height') !== '0px') {
            handleClose()
        } else {
            handleOpen()
        }
    })

    // if scrolling stop close sidebar
    document.addEventListener('scrollStop', () => {
        handleClose()
    }, false);

    /**
     *  adding scrolling and change navigation 
     * 
     *
     */

    // get elements
    const elements = $('.sozi-ui__menu-list a[href*="#"]')
    const offset = 25

    // add current to navigation
    const handleCurrent = function(hash) {
        $(".sozi-ui__menu-list a[href$='" + hash + "']").first().addClass('sozi-ui__menu-item--current')
    }

    // 
    const handleScroll = function() {

        // if found
        let hasFound = false

        // get result
        let result = undefined

        if (window.pageYOffset > offset) {
            $('body').addClass('has-scrolled')
        } else {
            $('body').removeClass('has-scrolled')
        }

        elements.each((index, element) => {
 
            // getting target
            const target = $(element.hash).first()

            if (!target[0]) {
                return
            }

            const offsetTop = target[0].getBoundingClientRect().top + window.pageYOffset

            let next = undefined

            // check for next element
            if (elements[index + 1]) {
                next = $(elements[index + 1].hash)
            }

            // check if element is visible
            if (offsetTop - (window.innerHeight / 2) <= (window.pageYOffset + offset)) {
                result = target
            }
        })

        if (result) {
            elements.removeClass('sozi-ui__menu-item--current')
            handleCurrent(result[0].id)
        }
    }

    window.addEventListener('scroll', throttle(300, handleScroll), false)

    // if hash is in url, if not get first element
    if (window.location.hash.substr(1)) {
        handleCurrent(window.location.hash.substr(1))
    } else {
        handleCurrent($('.sozi-ui__menu-list a[href*="#"]').first()[0].hash)
    }
})
